package org.recursed.w.client.about;

import org.recursed.w.client.characteristics.HasVisibility;

import com.google.gwt.event.dom.client.HasClickHandlers;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.RootPanel;
import com.google.inject.Inject;
import com.google.inject.Singleton;

@Singleton
public class AboutDisplay implements AboutPresenter.Display {

    private static String OVERLAY_ID = "overlay";
    private static String ABOUT_ID = "about";
    private static String CLOSE_STYLE = "close";
    private static String STYLE_OVERLAY = "blackout";
    private static String STYLE_ABOUT = "about";

    private RootPanel overlay;
    private RootPanel aboutDiv;
    private Label close;
    private HasVisibility visibility;

    @Inject
    public AboutDisplay() {
        overlay = RootPanel.get(OVERLAY_ID);
        aboutDiv = RootPanel.get(ABOUT_ID);
        close = new Label("close");
        close.setStyleName(CLOSE_STYLE);
        aboutDiv.add(close);
        createVisibility();
    }
    
    private void createVisibility() {
        visibility = new HasVisibility() {
            
            @Override
            public void setVisibility(boolean isVisibile) {
                if (isVisibile) {
                    overlay.setVisible(true);
                    aboutDiv.setVisible(true);
                } else {
                    overlay.setVisible(false);
                    aboutDiv.setVisible(false);
                }
            }
        };
        overlay.setStyleName(STYLE_OVERLAY);
        aboutDiv.setStyleName(STYLE_ABOUT);
        visibility.setVisibility(false);
    }

    @Override
    public HasClickHandlers getCloseButton() {
        return close;
    }

    @Override
    public HasVisibility getVisibility() {
        return visibility;
    }

}
