package org.recursed.w.client.guice;

import org.recursed.w.client.rpc.BatchingRPCService;
import org.recursed.w.client.rpc.RPCService;
import org.recursed.w.client.rpc.RootRPCServiceImpl;
import org.recursed.w.shared.corerpc.ActionServiceAsync;

import com.google.inject.Inject;
import com.google.inject.Provider;
import com.google.inject.Singleton;

@Singleton
public class RPCServiceProvider implements Provider<RPCService>{

    private RPCService rpcService;

    @Inject
    public RPCServiceProvider(ActionServiceAsync actionServiceAsync) {
        RootRPCServiceImpl root = new RootRPCServiceImpl(actionServiceAsync);
        rpcService = new BatchingRPCService(root);
    }

    @Override
    public RPCService get() {
        return rpcService;
    }

}
