package org.recursed.w.client.guice;

import org.recursed.w.client.about.AboutDisplay;
import org.recursed.w.client.about.AboutPresenter;
import org.recursed.w.client.headlines.HeadlinesDisplay;
import org.recursed.w.client.headlines.HeadlinesPresenter;
import org.recursed.w.client.place.PlaceFactory;
import org.recursed.w.client.place.PlaceService;
import org.recursed.w.client.relationshipgraph.RelationshipGraphDisplay;
import org.recursed.w.client.relationshipgraph.RelationshipGraphPresenter;
import org.recursed.w.client.rpc.RPCService;
import org.recursed.w.client.search.SearchDisplay;
import org.recursed.w.client.search.SearchPresenter;
import org.recursed.w.client.search.WordSuggestOracle;
import org.recursed.w.client.summary.SummaryDisplay;
import org.recursed.w.client.summary.SummaryPresenter;
import org.recursed.w.client.worddetail.ChosenWordDisplay;
import org.recursed.w.client.worddetail.ChosenWordPresenter;
import org.recursed.w.shared.corerpc.ActionServiceAsync;

import com.google.gwt.inject.client.AbstractGinModule;
import com.google.inject.Singleton;

public class WClientModule extends AbstractGinModule {

    @Override
    protected void configure() {
        bind(ActionServiceAsync.class).toProvider(ActionServiceProvider.class);
        bind(RPCService.class).toProvider(RPCServiceProvider.class);
        bind(PlaceService.Factory.class).to(PlaceFactory.class).in(Singleton.class);
        bind(PlaceService.class).in(Singleton.class);
        bind(SummaryPresenter.Display.class).to(SummaryDisplay.class).in(Singleton.class);
        bind(ChosenWordPresenter.Display.class).to(ChosenWordDisplay.class).in(Singleton.class);
        bind(ChosenWordPresenter.class).in(Singleton.class);
        bind(RelationshipGraphPresenter.Display.class).to(RelationshipGraphDisplay.class).in(Singleton.class);
        bind(RelationshipGraphPresenter.class).in(Singleton.class);
        bind(AboutPresenter.Display.class).to(AboutDisplay.class).in(Singleton.class);
        bind(AboutPresenter.class).in(Singleton.class);
        bind(HeadlinesPresenter.Display.class).to(HeadlinesDisplay.class).in(Singleton.class);
        bind(HeadlinesPresenter.class).in(Singleton.class);
        bind(WordSuggestOracle.class).in(Singleton.class);
        bind(SearchPresenter.Display.class).to(SearchDisplay.class).in(Singleton.class);
        bind(SearchPresenter.class).in(Singleton.class);
    }

}
