package org.recursed.w.client.headlines;

import org.recursed.w.client.characteristics.HasHeadline;

import com.google.gwt.event.dom.client.HasClickHandlers;
import com.google.gwt.user.client.ui.HasText;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.RootPanel;
import com.google.inject.Inject;
import com.google.inject.Singleton;

@Singleton
public class HeadlinesDisplay implements HeadlinesPresenter.Display {

    private static final String HEADLINES_DIV_ID = "headlines";
    private static final String HEADLINE_STYLE = "headline";
    private HasHeadline[] headlines;

    @Inject
    public HeadlinesDisplay() {
        RootPanel myDiv = RootPanel.get(HEADLINES_DIV_ID);
        headlines = new HasHeadline[MAX_HEADLINES];
        for (int x=0; x<MAX_HEADLINES; x++) {
            final Label l = new Label();
            l.setStyleName(HEADLINE_STYLE);
            headlines[x] = new HasHeadline() {
                
                @Override
                public HasText getString() {
                    return l;
                }
                
                @Override
                public HasClickHandlers getClickHandlers() {
                    return l;
                }
            };
            myDiv.add(l);
        }
    }

    @Override
    public HasHeadline getHeadline(int position) {
        return headlines[position];
    }

}
