package org.recursed.w.client.place;

import org.recursed.w.shared.WordDTO;

public class WordDetailPlace extends Place {

    public static final String CODE = "w";
    /**
     * This is there for programmatic change places to decorate the URL.
     * Do not assume that it will be there for all place changes (and therefore expose it)
     * since browser driven ones may not have a reliable WordDTO. Bank on the ID only.
     */
    private WordDTO dto;
    private int id;

    public WordDetailPlace() {
        super(CODE);
    }

    public WordDetailPlace(WordDTO dto) {
        super(CODE);
        this.id = dto.getId();
        this.dto = dto;
    }
    

    public int getWordId() {
        return id;
    }

    @Override
    public String[] getTokenizedArguments() {
        if (this.dto != null) {
            return new String[] { "" + id, dto.getDisplayString() };
        } else {
            return new String[] { "" + id };
        }
    }

    @Override
    public void setTokens(String[] tokens) {
        if (tokens.length > 1) {
            id = new Integer(tokens[1]);
        }
    }

}
