package org.recursed.w.client.rpc;

import org.recursed.w.shared.corerpc.Response;

import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.RootPanel;

public abstract class ActionCallback<R extends Response> implements AsyncCallback<Response>{

    /**
     * Centrally managed failures..
     */
    @Override
    public void onFailure(Throwable caught) {
        RootPanel.get().add(new Label(caught.toString()));
    }

    @SuppressWarnings("unchecked")
    @Override
    public final void onSuccess(Response result) {
        got((R) result);
    }

    public abstract void got(R response);
}
