package org.recursed.w.client.rpc;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Set;

import org.recursed.w.shared.corerpc.BatchedResponse;
import org.recursed.w.shared.corerpc.Response;

public class BatchedActionCallback extends ActionCallback<BatchedResponse>{

    private HashMap<Integer, ArrayList<ActionCallback<?>>> callbackMap = new HashMap<Integer, ArrayList<ActionCallback<?>>>();

    public void addCallback(Integer counter, ActionCallback<?> callback) {
        ArrayList<ActionCallback<?>> callbacks = callbackMap.get(counter);
        if (callbacks == null) {
            callbacks = new ArrayList<ActionCallback<?>>();
        }
        callbacks.add(callback);
        callbackMap.put(counter, callbacks);
    }

    @Override
    public void got(BatchedResponse result) {
        Set<Integer> keySet = callbackMap.keySet();
        for (Integer key : keySet) {
            ArrayList<ActionCallback<?>> callbacks = callbackMap.get(key);
            Response r = result.getResponse(key);
            for (ActionCallback<?> callback : callbacks) {
                if (r != null) {
                    callback.onSuccess(r);
                } else {
                    Exception e = result.getException(key);
                    callback.onFailure(e);
                }
            }
        }
    }

}
