package org.recursed.w.client.rpc;

import org.recursed.w.shared.corerpc.Action;
import org.recursed.w.shared.corerpc.ActionServiceAsync;
import org.recursed.w.shared.corerpc.Response;

import com.google.inject.Inject;
import com.google.inject.Singleton;

/**
 * The innermost Russian doll in the rpc service pipeline. 
 * @author keerat
 *
 */
@Singleton
public class RootRPCServiceImpl implements RPCService{

    private ActionServiceAsync actionService;

    @Inject
    public RootRPCServiceImpl(ActionServiceAsync actionService) {
        this.actionService = actionService;
    }

    @Override
    public<A extends Action, R extends Response> void execute(A action, ActionCallback<R> callback) {
        try {
            actionService.execute(action, callback);
        } catch (Exception e) {
            callback.onFailure(e);
        }
    }

}
