package org.recursed.w.client.search;

import org.recursed.w.client.place.PlaceService;
import org.recursed.w.client.place.WordDetailPlace;
import org.recursed.w.shared.WordDTO;

import com.google.gwt.event.logical.shared.HasSelectionHandlers;
import com.google.gwt.event.logical.shared.SelectionEvent;
import com.google.gwt.event.logical.shared.SelectionHandler;
import com.google.gwt.user.client.Timer;
import com.google.gwt.user.client.ui.Focusable;
import com.google.gwt.user.client.ui.SuggestOracle.Suggestion;
import com.google.inject.Inject;
import com.google.inject.Singleton;

@Singleton
public class SearchPresenter {

    public interface Display extends Focusable {
        public HasSelectionHandlers<Suggestion> getSelectionHandlers();
    }

    private Display display;
    private PlaceService placeService;

    @Inject
    public SearchPresenter(Display display, PlaceService placeService) {
        this.display = display;
        this.placeService = placeService;
        Timer t = new Timer() {

            @Override
            public void run() {
                init();
            }
            
        };
        t.schedule(10);
    }

    private void init() {
        this.display.getSelectionHandlers().addSelectionHandler( new SelectionHandler<Suggestion>() {

            @Override
            public void onSelection(SelectionEvent<Suggestion> event) {
                WordDTO word = (WordDTO) event.getSelectedItem();
                WordDetailPlace wordDetailPlace = new WordDetailPlace(word);
                placeService.changePlace(wordDetailPlace);
                display.setFocus(false);
            }
        });
    }

}
