package org.recursed.w.client.worddetail;

import java.util.ArrayList;

import org.recursed.w.client.characteristics.HasWord;
import org.recursed.w.client.worddetail.ChosenWordPresenter.HasTrendArea;

import com.google.gwt.event.dom.client.HasClickHandlers;
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.FlowPanel;
import com.google.gwt.user.client.ui.HasText;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.RootPanel;
import com.google.inject.Inject;
import com.google.inject.Singleton;

@Singleton
public class ChosenWordDisplay implements ChosenWordPresenter.Display {

    private static final String DIV_CHOSEN_WORD = "chosen_word_container";
    private static final String DATES = "t_dates";
    private static final String WORD = "t_word";
    private static final String T_WORD_DIV = "t_words";
    
    private ArrayList<TrendArea> trendAreas;
    private int counter;

    @Inject
    public ChosenWordDisplay() {
        RootPanel rootPanel = RootPanel.get(DIV_CHOSEN_WORD);
        trendAreas = new ArrayList<TrendArea>();
        counter =0;
        for (int x = 0; x<10; x++) {
            TrendArea t = new TrendArea();
            rootPanel.add(t);
            trendAreas.add(t);
        }
    }
    
    @Override
    public HasTrendArea getTrendArea() {
        TrendArea trendArea = trendAreas.get(counter);
        counter++;
        return trendArea;
    }

    private class TrendArea extends Composite implements HasTrendArea {

        private FlowPanel div;
        private Label dates;
        private FlowPanel words;

        TrendArea () {
            div = new FlowPanel();
            dates = new Label();
            dates.setStyleName(DATES);
            div.add(dates);
            words = new FlowPanel();
            words.setStyleName(T_WORD_DIV);
            div.add(words);
            initWidget(div);
        }

        @Override
        public HasWord getNextWord() {
            final Label l = new Label();
            l.setStyleName(WORD);
            words.add(l);
            HasWord result = new HasWord() {

                @Override
                public HasClickHandlers getClickHandlers() {
                    return l;
                }

                @Override
                public HasText getText() {
                    return l;
                }
                
            };
            return result;
        }

        public void reset() {
            dates.setText(null);
            words.clear();
        }

        @Override
        public void setDateRange(String string) {
            dates.setText(string);
        }
    }

    @Override
    public void reset() {
        counter = 0;
        for (TrendArea ta : trendAreas) {
            ta.reset();
        }
    }
    
}
