package org.recursed.w.server;

import org.recursed.w.shared.corerpc.Action;
import org.recursed.w.shared.corerpc.Response;
/**
 * An interface that provides an RPC contract.
 * @author keerat
 * @param <A> the inbound Action to be serviced
 * @param <R> the type of Response to be packaged as a return
 */
public interface ActionHandler <A extends Action, R extends Response> {

    /**
     * Handle the processing of the supplied Action
     * @param action
     * @return a Response value
     */
    public R execute(A action);

}
