package org.recursed.w.server.handlers;

import java.util.HashMap;

import org.recursed.w.server.ActionHandler;
import org.recursed.w.shared.corerpc.Action;
import org.recursed.w.shared.corerpc.BatchedAction;
import org.recursed.w.shared.corerpc.BatchedResponse;
import org.recursed.w.shared.corerpc.Response;

public class BatchedActionHandler implements ActionHandler<BatchedAction, BatchedResponse>{

    private HandlerRegistry registry;
    //private ExecutorService threadpool = Executors.newCachedThreadPool();

    @Override
    public BatchedResponse execute(BatchedAction action) {
        HashMap<Integer,Action> actions = action.getActions();
        final BatchedResponse batchedResponse = new BatchedResponse();
        //StringBuilder batchData = new StringBuilder("Batch contains:");
        for (Integer key : actions.keySet()) {
            Action a = actions.get(key);
            //batchData.append("\n ").append(key).append(':').append(a.getClass());
            try {
                Response response = registry.execute(a);
                batchedResponse.addResponse(key, response);
            } catch (Exception e) {
                batchedResponse.addException(key, e);
            }
        }
        //System.out.println(batchData);
        return batchedResponse;
    }

    public void setRegistry(HandlerRegistry handlerRegistry) {
        this.registry = handlerRegistry;
    }

}
