package org.recursed.w.server.handlers;

import java.util.ArrayList;

import org.recursed.w.server.ActionHandler;
import org.recursed.w.server.sql.WordsDAO;
import org.recursed.w.shared.ChronoBands;
import org.recursed.w.shared.headlines.GetHeadlines;
import org.recursed.w.shared.headlines.GetHeadlinesResponse;
import org.recursed.w.shared.headlines.HeadlineDTO;

import com.google.inject.Inject;
import com.google.inject.Singleton;

@Singleton
public class GetHeadlinesHandler implements ActionHandler<GetHeadlines, GetHeadlinesResponse>{

    private static final long DURATION = 4l* ChronoBands.WEEK.getRangeInMillis();

    private WordsDAO wordsDAO;

    @Inject
    public GetHeadlinesHandler(WordsDAO wordsDAO) {
        this.wordsDAO = wordsDAO;
    }

    @Override
    public GetHeadlinesResponse execute(GetHeadlines action) {
        GetHeadlinesResponse response = new GetHeadlinesResponse();
        ArrayList<HeadlineDTO> headlines = wordsDAO.getHeadlines(action.getWordId(), System.currentTimeMillis() - DURATION);
        response.addHeadlines(headlines);
        return response;
    }

}
