package org.recursed.w.server.handlers;

import org.recursed.w.server.ActionHandler;
import org.recursed.w.server.sql.WordsDAO;
import org.recursed.w.shared.search.GetSuggestedWordsAction;
import org.recursed.w.shared.search.SuggestedWordsResponse;

import com.google.inject.Inject;
import com.google.inject.Singleton;

@Singleton
public class SuggestWordHandler implements ActionHandler<GetSuggestedWordsAction, SuggestedWordsResponse>{

    private WordsDAO dao;

    @Inject
    public SuggestWordHandler(WordsDAO dao) {
        this.dao = dao;
    }

    @Override
    public SuggestedWordsResponse execute(GetSuggestedWordsAction action) {
        String segment = action.getSegment();
        return dao.getSuggestions(segment);
    }

}
