#!/bin/perl

use AnalysisSupport;
use DatabaseSupport;
use Source;

use strict; 
use warnings;

my @sources = get_sources();
my $totalTime = "0";
my $articleCount = "0";
foreach my $source (@sources) {
 my $rssurl = $source->{rssurl};
     print "FEED| ", $rssurl, "\n";
     foreach my $item ( getItems($rssurl) ) {
      my $start = time;
      my $guid = $item->guid();
      if (!defined $guid) {
       $guid = $item->link();
      }
      #print "Checking if we should analyze: ",$guid,"\n";
      my $shouldAnalyze = is_article_analyzed($guid);
      if ($shouldAnalyze == 1) {
       #print "we don't need to analyze\n";
      } else {
       my $title = $item->title();
       print "TITLE: ".$title."\n";
       my $description = extractText( $item->description() );
       my $titleText = extractText($item->title());
       my $analysis_ref = analyze($titleText.". ".$description);
       my $finish = time;
       my $total = $finish - $start;
       $totalTime = $totalTime + $total;
       insert_article_analysis($source, $title, $guid, $analysis_ref);
       #print "time: ", $total, "s\n";
       $articleCount++;
     }
    }
}

if ($articleCount > 0) {
 print "\nAverage time per article ($articleCount) is: ", ($totalTime/$articleCount), "\n";
} else {
 #print "\nNo articles analyzed\n";
}
