#!/bin/perl

use DatabaseSupport;

use strict;
use warnings;

print "Getting all words\n";

# Pass 1: compute mean
my @words = get_all_words();
my $count = scalar @words;
print "Total words: ", $count, "\n";
my $sum = 0;
foreach my $word (@words) {
 $sum = $sum + $word->{frequencySum};
}
my $mean = $sum/$count;
print "Mean: ", $mean, "\n";

# Pass 2: compute std dev
my $sumOfSquares = 0;
foreach my $word (@words) {
 my $meanDiff = $word->{frequencySum} - $mean;
 $meanDiff = $meanDiff * $meanDiff;
 $sumOfSquares = $sumOfSquares + $meanDiff;
}
my $averageSumOfSquares = $sumOfSquares/$count;
my $stdDev = sqrt $averageSumOfSquares;
print "Std Dev: ", $stdDev, "\n";

# Pass 3: identify stop words (3x beyond std dev)
my $limit = $mean + (3 * $stdDev);
print "Setting limit to: ", $limit, "\n\n";
foreach my $word (@words) {
 if ($limit - $word->{frequencySum} < 0) {
  print $word->{label}, " is a stop word (", $word->{frequencySum}, ")\n";
  print "\n\nProceed (n)o, or (y)es?\n";
  my $proceed = <>;
  mark_as_ignorable($word->{id});
 }
}


