package org.recursed.w.server.servlet;

import java.util.HashMap;
import java.util.Set;

import com.google.inject.Inject;
import com.google.inject.Singleton;

@Singleton
public final class Histogram {

    private HashMap<Class<?>, HashMap<Integer, Integer>> data;

    @Inject
    protected Histogram() {
        data = new HashMap<Class<?>, HashMap<Integer, Integer>>();
    }

    public void record(Object o, long start, long finish) {
        try {
            Long longDuration = finish - start;
            int duration = longDuration.intValue()/1000;
            HashMap<Integer, Integer> histogram = data.get(o.getClass());
            if (histogram == null) {
                histogram = new HashMap<Integer, Integer>();
            }
            Integer tally = histogram.get(duration);
            if (tally == null) {
                tally = 0;
            }
            tally++;
            histogram.put(duration, tally);
            data.put(o.getClass(), histogram);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public Set<Class<?>> getAllKeys() {
        return data.keySet();
    }

    public HashMap<Integer, Integer> getData(Class<?> c) {
        return data.get(c);
    }

}
