package org.recursed.w.server.sql;

import java.util.ArrayList;

import org.recursed.w.server.handlers.WordDetailHandler;
import org.recursed.w.shared.ChronoBands;
import org.recursed.w.shared.WordDTO;
import org.recursed.w.shared.trends.TrendDTO;

import com.google.inject.Inject;


public class Test {

    @Inject
    public Test(WordDetailHandler handler, WordsDAO dao) {
        long now = System.currentTimeMillis();
        //RelatedWordResult rwr = dao.getRelatedWords(9961, now - ChronoBands.WEEK.getRangeInMillis()*4);
        RelatedWordResult rwr = dao.getRelatedWords(1976, now - ChronoBands.WEEK.getRangeInMillis()*4);
        TrendCalculator tc = new TrendCalculator(rwr);
        ArrayList<TrendDTO> trends = tc.getTrends(20);
        for (TrendDTO t : trends) {
            for (String s: t.getDates())
                System.out.print(s + " ");
            System.out.println();
            for (WordDTO w : t.getWords())
                System.out.println(w.getDisplayString());
            System.out.println();
        }
        System.out.println("Done");
    }

    public static void main(String[] args) {
        Pool pool = new Pool();
        WordsDAO wd = new WordsDAO(pool);
        WordDetailHandler h = new WordDetailHandler(wd);
        new Test(h, wd);
    }
}
