package org.recursed.w.shared;

import java.io.Serializable;

import com.google.gwt.user.client.rpc.IsSerializable;

public enum ChronoBands implements IsSerializable, Serializable {
    HOUR(1, "h"), DAY(24, "d"), WEEK(24 * 7, "w");

    private ChronoBands() {
    }

    private int range;
    private String idPrefix;

    private ChronoBands(int range, String idPrefix) {
        this.range = range;
        this.idPrefix = idPrefix;
    }

    public int getRangeInHours() {
        return range;
    }

    public long getRangeInMillis() {
        return 1000L * 60L * 60L * new Long(range).longValue();
    }

    public String getIDPrefix() {
        return idPrefix;
    }
}
