package org.recursed.w.shared;

import org.recursed.w.shared.corerpc.Action;

public class GetWordDetailAction implements Action {

    private static final long serialVersionUID = 1L;
    public static final int DEFAULT_MAX_WORDS = 20;

    @SuppressWarnings("unused")
    private GetWordDetailAction() {}

    private int id;
    private int maxWords;
    
    public GetWordDetailAction(int wordId, int maxWords) {
        this.id = wordId;
        this.maxWords = maxWords;
    }

    public int getWordId() {
        return id;
    }

    public int getMaxWords() {
        return maxWords;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + id;
        result = prime * result + maxWords;
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        GetWordDetailAction other = (GetWordDetailAction) obj;
        if (id != other.id)
            return false;
        if (maxWords != other.maxWords)
            return false;
        return true;
    }

    
}
