package org.recursed.w.shared;

import java.util.ArrayList;
import java.util.HashMap;

import org.recursed.w.shared.corerpc.Response;

public class GroupedWordDetail implements Response {

    private static final long serialVersionUID = 1L;

    private HashMap<WordDTO, ArrayList<WordDTO>> relationships;
    
    public GroupedWordDetail() {
        relationships = new HashMap<WordDTO, ArrayList<WordDTO>>();
    }

    public void addLinkage(WordDTO source, WordDTO wordDTO) {
        ArrayList<WordDTO> relatedWords = relationships.get(source);
        if (relatedWords == null) {
            relatedWords = new ArrayList<WordDTO>();
        }
        relatedWords.add(wordDTO);
        relationships.put(source, relatedWords);
    }

    public HashMap<WordDTO, ArrayList<WordDTO>> getLinkages() {
        return relationships;
    }

}
