package org.recursed.w.shared;

import java.io.Serializable;

import com.google.gwt.user.client.rpc.IsSerializable;
import com.google.gwt.user.client.ui.SuggestOracle.Suggestion;

/**
 * Represents a Word with both ID and presentation version.
 * 
 * @author keerat
 */
public class WordDTO implements IsSerializable, Serializable, Suggestion {

    private static final long serialVersionUID = 1L;
    private int id, count;
    private String label;

    @SuppressWarnings("unused")
    private WordDTO() {
    }

    public WordDTO(int id, String label, int count) {
        this.id = id;
        this.label = label;
        this.count = count;
    }

    public int getId() {
        return id;
    }

    @Override
    public String getDisplayString() {
        return label;
    }

    public int getCount() {
        return count;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + id;
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        WordDTO other = (WordDTO) obj;
        if (id != other.id)
            return false;
        return true;
    }

    @Override
    public String getReplacementString() {
        return label;
    }


}
