package org.recursed.w.shared;

import java.util.ArrayList;
import java.util.HashSet;

import org.recursed.w.shared.corerpc.Response;
import org.recursed.w.shared.trends.TrendDTO;

public class WordDetail implements Response {

    private static final long serialVersionUID = 1L;

    private WordDTO coreWord;
    private ArrayList<TrendDTO> trends;

    @SuppressWarnings("unused")
    private WordDetail() {
        trends = new ArrayList<TrendDTO>();
    }

    public WordDetail(WordDTO coreWord) {
        this.coreWord = coreWord;
    }

    public void setTrends(ArrayList<TrendDTO> trends) {
        this.trends = trends;
    }

    public ArrayList<TrendDTO> getTrends() {
        return trends;
    }

    public WordDTO getCoreWord() {
        return coreWord;
    }

    public HashSet<WordDTO> getRandomRelatedWords(int max) {
        HashSet<WordDTO> allWordDTOs = new HashSet<WordDTO>();
        for (TrendDTO t : trends) {
            ArrayList<WordDTO> words = t.getWords();
            allWordDTOs.addAll(words);
        }
        int counter = 0;
        HashSet<WordDTO> result = new HashSet<WordDTO>();
        for (WordDTO dto : allWordDTOs) {
            if (counter == 6) {
                break;
            }
            result.add(dto);
            counter++;
        }
        return result;
    }
}
