use warnings;
use strict;
use WordNet::QueryData;

my $wn       = WordNet::QueryData->new();
my @nounList = sort( $wn->listAllWords("noun") );
my @verbList = sort( $wn->listAllWords("verb") );
#print "Nouns (", scalar @nounList, ") and verbs (", scalar @verbList,
#  ") loaded.";
#print "\n";
my %foundNouns = ();

sub binSearch {
 my $result = 0;
 my $searchFor = shift;
 my $cachedValue = $foundNouns{$searchFor};
 if (defined($cachedValue)) {
  #print "*";
  if ($cachedValue == 1) {
   return 1;
  } else {
   return 0;
  }
 } else {
  #print "-";
 }
 my @list      = @nounList;
 my $listSize  = scalar @list;
 my $left      = 0;
 my $right     = $listSize - 1;
 my $middle = 0;
 my $direction;
 while ( $left < $right) {
  #print "While searching for $searchFor we are at $left $middle $right\n";
  $middle = sprintf("%.0f", $left + ( ( $right - $left ) / 2 ));
  if ( $list[$middle] eq $searchFor ) {
   $result = 1;
   $foundNouns{$searchFor}=1;
   return $result;
  }
  else {
   if ( $list[$middle] lt $searchFor ) {
    $left = $middle + 1;
   }
   else {
    $right = $middle -1;
   }
  }
 }
 $foundNouns{$searchFor} = 2;
 return $result;
}

sub lookupWord {
 my $word  = shift;
 if ($word eq "") {
  return 0;
 }
 if (binSearch ($word) == 1) {
  return 1;
 }
 return 0;
}

1;